/*******************************************************************************
*  skVC0706.c - VC0706-chipp֐Cu                                    *
*               (Digital Video Processor VC0706)                               *
*                                                                              *
*    skVC0706x      - ̃Cu𐶐鎞̏(RXgN^)   *
*    begin          -                                                *
*    flush          - VAMobt@̏                           *
*    GetError       - G[𓾂鏈                                     *
*    GetVersion     - t@[EFÃo[W𓾂鏈                     *
*    Reset          - J̃Zbgs                               *
*    PowerCtl       - ȓd̓[h̐s                             *
*    GetImageSize   - 摜̑傫𓾂鏈                                   *
*    GetColorSts    - COLOR̃[h𓾂鏈                                  *
*    SetColorCtl    - COLOR̃[hݒ肷鏈                              *
*    GetCompression - 摜̈k𓾂鏈                                   *
*    SetCompression - 摜̈kݒ肷鏈                               *
*    MotionCtlEnable- [VĎ鏈                             *
*    SetMotionCtl   - ̃j^[O𐧌䂷鏈                       *
*    MotionDetect   - [VĎs                                 *
*    TakePicture    - 摜Lv`[鏈                               *
*    ReadPicture    - 摜f[^ǂݍޏ                                 *
*    ResumeVideo    - rfIĊJ鏈                                     *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.01    2017-03-20  ޒH[(ނ)  Create                            *
* ============================================================================ *
*  Arduino IDE 1.8.1 (Ardino Duemilanove 328/UNO)                              *
*******************************************************************************/
#include "skVC0706.h"


// MR}hɑ΂ԓǂݍޏ
int skVC070x::read(char *buff,int len)
{
     uint16_t dt ;
     int i , t , rflg ;

     i = t = 0 ;
     rflg  = 0 ;
     while(1) {
          if (swSerial->available() > 0) {
               dt = swSerial->read() ;
               if (dt == 0x76) rflg = 1 ;
               if (rflg == 1) {
                    *buff = (char)dt ;
                    buff++ ;
                    i++ ;
                    if (i >= len) return i ; // MI
               }
               t = 0 ;
          }
          delayMicroseconds(10) ;
          t++ ;
          if (t >= 10000) return -1 ;        // 100msŃ^CI[o[
     }
     return i ;
}
// R}h̑Mƕԓ̏s
int skVC070x::sendread(char *cmd,int snd_su,int rcv_su)
{
     Erro.cmd_no = *(cmd+2) ;
     Erro.err_no = 0 ;
     swSerial->write(cmd,snd_su) ;
     if (read(ReadReturnBuff,rcv_su) == rcv_su) {
          if (ReadReturnBuff[2] == Erro.cmd_no) {
               if (ReadReturnBuff[3] == 0x00) {
                    return 0 ;
               } else Erro.err_no = ReadReturnBuff[3] ;// G[ԂꂽB
          } else Erro.err_no = 10 ;     // MR}hɑ΂ԓłȂB
     } else Erro.err_no = 11 ;          // M^CI[o[
     return -1 ;
}
/*******************************************************************************
*  skVC0706x(ss_p)                                                             *
*    ̊֐Cu𐶐鎞̏(RXgN^)                *
*                                                                              *
*    *ss_p : SoftwareSerialIuWFNg̃|C^[n                      *
*******************************************************************************/
skVC070x::skVC070x(SoftwareSerial *ss_p)
{
     Erro.cmd_no = 0 ;
     Erro.err_no = 0 ;
     swSerial = ss_p ;   // SoftwareSerial̃|C^[Zbg
}
/*******************************************************************************
*  begin(baud)                                                                 *
*                                                                    *
*    SoftwareSerial̏ƃJ̃Zbgs܂B                      *
*                                                                              *
*    baud : SoftwareSerial̒ʐMxw肵܂AftHg38400bpsł     *
*******************************************************************************/
void skVC070x::begin(uint32_t baud)
{
     swSerial->begin(baud) ;
     flush() ;           // Mobt@̃NA
//     Reset() ;
}
/*******************************************************************************
*  flush()                                                                     *
*    VAMobt@̏                                            *
*    ܂Ă镪̎Mobt@ǂݎ̂Ă܂B                              *
*******************************************************************************/
void skVC070x::flush()
{
     char dt ;

     while(swSerial->available() > 0) {
          dt = swSerial->read() ;
     }
}
/*******************************************************************************
*  ans = GetError()                                                            *
*    G[𓾂鏈                                                      *
*    ŌɎM̃G[ԍԂ܂B                                  *
*                                                                              *
*    ans  : G[ԍԂ                                                   *
*******************************************************************************/
uint16_t skVC070x::GetError()
{
     return Erro.info ;
}
/*******************************************************************************
*  ans = Reset()                                                               *
*    J̃Zbgs                                                *
*    ZbgƓdONƓbZ[W𑗐Mė̂œǂݎ̂Ă        *
*    dON2-3băR}hwJnlɃf[^V[gɏėL̂ *
*    Zbg2-3b҂ǂB                               *
*                                                                              *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::Reset()
{
     char cmd[4]= {0x56,0x00,0x26,0x00} ;    // SYSTEM_RESET
     int ans ;

     if ((ans=sendread(cmd,4,5)) == 0) {
          delay(1000) ;       // J̃bZ[W͂̊Ԃɓǂݎ̂Ă
     }
     flush() ;                // Mobt@̃NA
     return ans ;
}
/*******************************************************************************
*  ans = GetVersion()                                                          *
*    t@[EFÃo[W𓾂鏈                                      *
*                                                                              *
*    *ans : ̓o[W񕶎ւ̃AhXԂ(F"VC0703 1.00")  *
*           s͂OԂ                                                   *
*******************************************************************************/
char *skVC070x::GetVersion()
{
     char cmd[4]= {0x56,0x00,0x11,0x00} ;    // GEN_VERSION

     if (sendread(cmd,4,16) == 0) {
           ReadReturnBuff[16] = 0x00 ;
           return (char *)&ReadReturnBuff[5] ;
     }
     return 0 ;
}
/*******************************************************************************
*  ans = PowerCtl(info,time)                                                   *
*    ȓd̓[h̐s                                              *
*                                                                              *
*    info : O=OFF P=ON ̑=timeԂŏȓd̓[hɓ                   *
*    time : 10msPʂŎw肷                                                 *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::PowerCtl(int info,uint16_t time)
{
     char cmd[8]= {0x56,0x00,0x3E,0x03,0x00,0x01,0x00,0x00} ;    // POWER_SAVE_CTRL
     int  su ;

     switch(info) {
        case 0:     // ȓd̓[hOFF
        case 1:     // ȓd̓[hON
               cmd[6] = (char)info ;
               su = 7 ;
               break ;
        default :   // w莞Ԃŏȓd̓[hɓ
               cmd[3] = 0x04 ;
               cmd[4] = 0x01 ;
               cmd[5] = 0x04 ;
               cmd[6] = (char)(time >> 8) ;
               cmd[7] = (char)(time & 0x00FF) ;
               su = 8 ;
               break ;
     }
     return sendread(cmd,su,5) ;
}
/*******************************************************************************
*  ans = GetCompression()                                                      *
*    摜̈k𓾂鏈                                                    *
*                                                                              *
*    ans : 0x00`0xFF                                                  *
*          s-1Ԃ                                                    *
*******************************************************************************/
int skVC070x::GetCompression()
{
     char cmd[8]= {0x56,0x00,0x30,0x04,0x01,0x01,0x12,0x04} ;         // READ_DATA

     if (sendread(cmd,8,6) == 0) {
           return (int)ReadReturnBuff[5] ;
     }
     return -1 ;
}
/*******************************************************************************
*  ans = SetCompression(val)                                                   *
*    摜̈kݒ肷鏈                                                *
*    Zbgƌɖ߂܂B                                              *
*                                                                              *
*    val  : 摜k̎w(lƈk)                   *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::SetCompression(int val)
{
     char cmd[9]= {0x56,0x00,0x31,0x05,0x01,0x01,0x12,0x04,0x00} ;    // WRITE_DATA

     cmd[8] = val ;
     return sendread(cmd,9,5) ;
}
/*******************************************************************************
*  ans = GetColorSts()                                                         *
*    COLOR̃[h𓾂鏈                                                   *
*                                                                              *
*    ans :  0=ݒ  1=COLOR[h  2=[h                    *
*          s-1Ԃ                                                    *
*******************************************************************************/
int skVC070x::GetColorSts()
{
     char cmd[4]= {0x56,0x00,0x3D,0x00} ;         // COLOR_STATUS

     if (sendread(cmd,4,8) == 0) {
          return (int)ReadReturnBuff[6] ;
     }
     return -1 ;
}
/*******************************************************************************
*  ans = SetColorCtl(val)                                                      *
*    COLOR̃[hݒ肷鏈                                               *
*    [hɂČAFHɂȂŔɂȂȂH    *
*                                                                              *
*    val  : COLOR̃[h̎w(0=ݒ  1=COLOR[h  2=[h) *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::SetColorCtl(int val)
{
     char cmd[6]= {0x56,0x00,0x3C,0x02,0x01,0x00} ;    // COLOR_CTRL

     cmd[5] = val ;
     return sendread(cmd,6,5) ;
}
/*******************************************************************************
*  ans = GetImageSize()                                                        *
*    摜̑傫𓾂鏈                                                    *
*                                                                              *
*    ans :  0(0x00)=640x480  17(0x11)=320x240  34(0x22)=160x120        *
*          s-1Ԃ                                                    *
*******************************************************************************/
int skVC070x::GetImageSize()
{
     char cmd[8]= {0x56,0x00,0x30,0x04,0x04,0x01,0x00,0x19} ;         // READ_DATA

     if (sendread(cmd,8,6) == 0) {
           return (int)ReadReturnBuff[5] ;
     }
     return -1 ;
}
/*******************************************************************************
*  ans = SetImageSize(sz)                                                      *
*    摜̑傫ݒ肷鏈                                                *
*    ̊֐Őݒ肵ĂA640x480̂܂ܕςȂB                           *
*    肭삹AZbgĂ_łL邩słB      *
*                                                                              *
*    sz   : 摜TCY̎w                                             *
*           0(0x00)=640x480  17(0x11)=320x240  34(0x22)=160x120                *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::SetImageSize(int sz)
{
     char cmd[9]= {0x56,0x00,0x31,0x05,0x04,0x01,0x00,0x19,0x00} ;    // WRITE_DATA

     cmd[8] = sz ;
     return sendread(cmd,9,5) ;
}
/*******************************************************************************
*  ans = MotionCtlEnable()                                                     *
*    [VĎ鏈                                              *
*                                                                              *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::MotionCtlEnable()
{
     char cmd[7]= {0x56,0x00,0x42,0x03,0x00,0x01,0x01} ;   // MOTION_CTRL

     // [VĎgpo悤ɋ
     return sendread(cmd,7,5) ;
}
/*******************************************************************************
*  ans = SetMotionCtl(val)                                                     *
*    ̃j^[O𐧌䂷鏈                                        *
*                                                                              *
*    val  : 1=j^[OJn  0=j^[O~                         *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::SetMotionCtl(int val)
{
     char cmd[5]= {0x56,0x00,0x37,0x01,0x00} ;             // COMM_MOTION_CTRL

     // j^[O̐ݒ
     cmd[4] = val ;
     return sendread(cmd,5,5) ;
}
/*******************************************************************************
*  ans = MotionDetect()                                                        *
*    [VĎs                                                  *
*                                                                              *
*    ans  : -1 = MĂȂ̓G[M                    *
*           ȊÓAMR}hԍԂ܂B                       *
*******************************************************************************/
int skVC070x::MotionDetect()
{
     if (swSerial->available() > 0) {
          if (read(ReadReturnBuff,4) == 4) {
               if ((ReadReturnBuff[3] == 0x00)) {
                    return ReadReturnBuff[2] ;    // MR}hԍԂ
               } // else errorԂ
          } // else ͎M^CI[o[
     }
     return -1 ;
}
/*******************************************************************************
*  ans = ResumeVideo()                                                         *
*    rfIĊJ鏈                                                      *
*                                                                              *
*    ans  : ͂OԂ                                                   *
*           s-1Ԃ                                                   *
*******************************************************************************/
int skVC070x::ResumeVideo()
{
     char cmd[5]= {0x56,0x00,0x36,0x01,0x03} ;   // FBUF_CTRL(resume frame)

     return sendread(cmd,5,5) ;
}
/*******************************************************************************
*  ans = TakePicture()                                                         *
*    摜Lv`[鏈                                                *
*    ̊֐R[ꍇ́ArfINĂ鎖OłB            *
*                                                                              *
*    ans : ̓Lv`[摜̃t@CTCYԂ                  *
*          s͂OԂ                                                    *
*******************************************************************************/
uint32_t skVC070x::TakePicture()
{
     union {
          struct {
               unsigned char b1 ;  // Low byte
               unsigned char b2 ;
               unsigned char b3 ;
               unsigned char b4 ;  // High byte
          } ;
          uint32_t  l ;
     } dt ;
     char cmd1[5]= {0x56,0x00,0x36,0x01,0x00} ;   // FBUF_CTRL(stop current frame)
     char cmd2[5]= {0x56,0x00,0x34,0x01,0x00} ;   // GET_FBUF_LEN(JPEG file size)

     flush() ;                     // Mobt@̃NA
     // NĂrfI~(Lv`[)
     if (sendread(cmd1,5,5) == 0) {
          // 摜̃t@CTCY𓾂
          if (sendread(cmd2,5,9) == 0) {
               dt.b4 = ReadReturnBuff[5] ;
               dt.b3 = ReadReturnBuff[6] ;
               dt.b2 = ReadReturnBuff[7] ;
               dt.b1 = ReadReturnBuff[8] ;
               return dt.l ;
          }
     }
     return 0 ;
}
/*******************************************************************************
*  ans = ReadPicture(adrs,len)                                                 *
*    摜f[^ǂݍޏ                                                  *
*    Lv`[摜f[^FBUFǂݍ݂܂B                        *
*                                                                              *
*    adrs : ǂݍFBUF̃AhXw肷                                   *
*    len  : ǂݍރf[^̒w肷(VC070x_READDATA_BUFFSIZƂ)    *
*    *ans : ǂݍ񂾃f[^̊i[Ԃ                                     *
*******************************************************************************/
char *skVC070x::ReadPicture(uint16_t adrs,int len)
{
     uint16_t dt ;
     int i , c ;
     char cmd[16]= {0x56,0x00,0x32,0x0c,0x00,0x0A,
                    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0A} ;   // READ_FBUF

     // len̒̃f[^𑗂w
     cmd[8] = adrs >> 8 ;     // FBUF̓ǂݏoAhXHIGH
     cmd[9] = adrs & 0xFF ;   // FBUF̓ǂݏoAhXLOW
     cmd[12]= len >> 8 ;      // ǂݏof[^HIGH
     cmd[13]= len & 0xFF ;    // ǂݏof[^LOW
     cmd[14]= VC070X_READDATA_DELAY >> 8 ;      // Interval timeHIGH
     cmd[15]= VC070X_READDATA_DELAY & 0xFF ;    // Interval timeLOW
     swSerial->write(cmd,16) ;
     // f[^M
     // 擪ƍŌɂ"76 00 32 00 00"L̂œǂݎ̂Ă
     i = c = 0 ;
     while(1) {
          if (swSerial->available() > 0) {
               dt = swSerial->read() ;
               i++ ;
               if (i>5) {
                    // 6oCgڂlen̒ǂݍ
                    ReadReturnBuff[c] = dt ;
                    c++ ;
                    if (c == len) break ;
               }
          }
     }
     i = 0 ;
     while(1) {
          if (swSerial->available() > 0) {
               dt = swSerial->read() ;
               i++ ;
               if (i==4) c = dt ;  // ʐM󋵂̎o
               if (i>=5) break ;
          }
     }
     return (char *)&ReadReturnBuff ;
}
